/* Utils.c generated by valac 0.42.7, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://github.com/elementary/camera)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Marcus Wichelmann <marcus.wichelmann@hotmail.de>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>

typedef enum  {
	CAMERA_UTILS_ACTION_TYPE_PHOTO,
	CAMERA_UTILS_ACTION_TYPE_VIDEO
} CameraUtilsActionType;


#define CAMERA_UTILS_TYPE_ACTION_TYPE (camera_utils_action_type_get_type ())
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



GType camera_utils_action_type_get_type (void) G_GNUC_CONST;
gchar* camera_utils_get_new_media_filename (CameraUtilsActionType action_type);
gchar* camera_utils_build_media_filename (const gchar* filename,
                                          CameraUtilsActionType action_type);
gchar* camera_utils_get_media_directory (CameraUtilsActionType action_type);


GType
camera_utils_action_type_get_type (void)
{
	static volatile gsize camera_utils_action_type_type_id__volatile = 0;
	if (g_once_init_enter (&camera_utils_action_type_type_id__volatile)) {
		static const GEnumValue values[] = {{CAMERA_UTILS_ACTION_TYPE_PHOTO, "CAMERA_UTILS_ACTION_TYPE_PHOTO", "photo"}, {CAMERA_UTILS_ACTION_TYPE_VIDEO, "CAMERA_UTILS_ACTION_TYPE_VIDEO", "video"}, {0, NULL, NULL}};
		GType camera_utils_action_type_type_id;
		camera_utils_action_type_type_id = g_enum_register_static ("CameraUtilsActionType", values);
		g_once_init_leave (&camera_utils_action_type_type_id__volatile, camera_utils_action_type_type_id);
	}
	return camera_utils_action_type_type_id__volatile;
}


gchar*
camera_utils_get_new_media_filename (CameraUtilsActionType action_type)
{
	gchar* result = NULL;
	gchar* time = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint file_id = 0;
	gchar* next_filename = NULL;
	gchar* _tmp4_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
#line 29 "../src/Utils.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 29 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 29 "../src/Utils.vala"
	_tmp2_ = g_date_time_format (_tmp1_, "%F%H:%M:%S");
#line 29 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 29 "../src/Utils.vala"
	_g_date_time_unref0 (_tmp1_);
#line 29 "../src/Utils.vala"
	time = _tmp3_;
#line 31 "../src/Utils.vala"
	file_id = 0;
#line 32 "../src/Utils.vala"
	_tmp4_ = g_strdup ("");
#line 32 "../src/Utils.vala"
	next_filename = _tmp4_;
#line 98 "Utils.c"
	{
		gboolean _tmp5_ = FALSE;
#line 34 "../src/Utils.vala"
		_tmp5_ = TRUE;
#line 34 "../src/Utils.vala"
		while (TRUE) {
#line 105 "Utils.c"
			gchar* _tmp10_ = NULL;
			gint _tmp11_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gint _tmp19_;
#line 34 "../src/Utils.vala"
			if (!_tmp5_) {
#line 113 "Utils.c"
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gboolean _tmp9_;
#line 37 "../src/Utils.vala"
				_tmp6_ = next_filename;
#line 37 "../src/Utils.vala"
				_tmp7_ = camera_utils_build_media_filename (_tmp6_, action_type);
#line 37 "../src/Utils.vala"
				_tmp8_ = _tmp7_;
#line 37 "../src/Utils.vala"
				_tmp9_ = !g_file_test (_tmp8_, G_FILE_TEST_EXISTS);
#line 37 "../src/Utils.vala"
				_g_free0 (_tmp8_);
#line 37 "../src/Utils.vala"
				if (_tmp9_) {
#line 37 "../src/Utils.vala"
					break;
#line 132 "Utils.c"
				}
			}
#line 34 "../src/Utils.vala"
			_tmp5_ = FALSE;
#line 35 "../src/Utils.vala"
			_tmp11_ = file_id;
#line 35 "../src/Utils.vala"
			if (_tmp11_ > 0) {
#line 141 "Utils.c"
				gint _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 35 "../src/Utils.vala"
				_tmp12_ = file_id;
#line 35 "../src/Utils.vala"
				_tmp13_ = g_strdup_printf ("%i", _tmp12_);
#line 35 "../src/Utils.vala"
				_tmp14_ = _tmp13_;
#line 35 "../src/Utils.vala"
				_tmp15_ = g_strconcat ("-", _tmp14_, NULL);
#line 35 "../src/Utils.vala"
				_g_free0 (_tmp10_);
#line 35 "../src/Utils.vala"
				_tmp10_ = _tmp15_;
#line 35 "../src/Utils.vala"
				_g_free0 (_tmp14_);
#line 160 "Utils.c"
			} else {
				gchar* _tmp16_;
#line 35 "../src/Utils.vala"
				_tmp16_ = g_strdup ("");
#line 35 "../src/Utils.vala"
				_g_free0 (_tmp10_);
#line 35 "../src/Utils.vala"
				_tmp10_ = _tmp16_;
#line 169 "Utils.c"
			}
#line 35 "../src/Utils.vala"
			_tmp17_ = time;
#line 35 "../src/Utils.vala"
			_tmp18_ = g_strconcat (_tmp17_, _tmp10_, NULL);
#line 35 "../src/Utils.vala"
			_g_free0 (next_filename);
#line 35 "../src/Utils.vala"
			next_filename = _tmp18_;
#line 36 "../src/Utils.vala"
			_tmp19_ = file_id;
#line 36 "../src/Utils.vala"
			file_id = _tmp19_ + 1;
#line 34 "../src/Utils.vala"
			_g_free0 (_tmp10_);
#line 185 "Utils.c"
		}
	}
#line 39 "../src/Utils.vala"
	_tmp20_ = next_filename;
#line 39 "../src/Utils.vala"
	_tmp21_ = camera_utils_build_media_filename (_tmp20_, action_type);
#line 39 "../src/Utils.vala"
	result = _tmp21_;
#line 39 "../src/Utils.vala"
	_g_free0 (next_filename);
#line 39 "../src/Utils.vala"
	_g_free0 (time);
#line 39 "../src/Utils.vala"
	return result;
#line 200 "Utils.c"
}


gchar*
camera_utils_build_media_filename (const gchar* filename,
                                   CameraUtilsActionType action_type)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* full_filename = NULL;
	gchar* _tmp1_;
	gchar* media_directory = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 42 "../src/Utils.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 43 "../src/Utils.vala"
	if (action_type == CAMERA_UTILS_ACTION_TYPE_PHOTO) {
#line 43 "../src/Utils.vala"
		_tmp0_ = "jpg";
#line 224 "Utils.c"
	} else {
#line 43 "../src/Utils.vala"
		_tmp0_ = "ogv";
#line 228 "Utils.c"
	}
#line 43 "../src/Utils.vala"
	_tmp1_ = g_strdup_printf ("%s.%s", filename, _tmp0_);
#line 43 "../src/Utils.vala"
	full_filename = _tmp1_;
#line 44 "../src/Utils.vala"
	_tmp2_ = camera_utils_get_media_directory (action_type);
#line 44 "../src/Utils.vala"
	media_directory = _tmp2_;
#line 46 "../src/Utils.vala"
	_tmp3_ = media_directory;
#line 46 "../src/Utils.vala"
	if (!g_file_test (_tmp3_, G_FILE_TEST_EXISTS)) {
#line 242 "Utils.c"
		const gchar* _tmp4_;
#line 47 "../src/Utils.vala"
		_tmp4_ = media_directory;
#line 47 "../src/Utils.vala"
		g_mkdir (_tmp4_, 0777);
#line 248 "Utils.c"
	}
#line 50 "../src/Utils.vala"
	_tmp5_ = media_directory;
#line 50 "../src/Utils.vala"
	_tmp6_ = full_filename;
#line 50 "../src/Utils.vala"
	_tmp7_ = g_build_filename (G_DIR_SEPARATOR_S, _tmp5_, _tmp6_, NULL);
#line 50 "../src/Utils.vala"
	result = _tmp7_;
#line 50 "../src/Utils.vala"
	_g_free0 (media_directory);
#line 50 "../src/Utils.vala"
	_g_free0 (full_filename);
#line 50 "../src/Utils.vala"
	return result;
#line 264 "Utils.c"
}


gchar*
camera_utils_get_media_directory (CameraUtilsActionType action_type)
{
	gchar* result = NULL;
	GUserDirectory _tmp0_ = 0;
	GUserDirectory user_dir = 0;
	gchar* media_directory = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 54 "../src/Utils.vala"
	if (action_type == CAMERA_UTILS_ACTION_TYPE_PHOTO) {
#line 54 "../src/Utils.vala"
		_tmp0_ = G_USER_DIRECTORY_PICTURES;
#line 282 "Utils.c"
	} else {
#line 54 "../src/Utils.vala"
		_tmp0_ = G_USER_DIRECTORY_VIDEOS;
#line 286 "Utils.c"
	}
#line 54 "../src/Utils.vala"
	user_dir = _tmp0_;
#line 55 "../src/Utils.vala"
	_tmp1_ = g_get_user_special_dir (user_dir);
#line 55 "../src/Utils.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 55 "../src/Utils.vala"
	media_directory = _tmp2_;
#line 57 "../src/Utils.vala"
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, media_directory, "Webcam", NULL);
#line 57 "../src/Utils.vala"
	result = _tmp3_;
#line 57 "../src/Utils.vala"
	_g_free0 (media_directory);
#line 57 "../src/Utils.vala"
	return result;
#line 304 "Utils.c"
}



